
#include <configs/platform-auto.h>

#define CONFIG_PHY_TI
#define CONFIG_ZYNQ_GEM_INTERFACE	PHY_INTERFACE_MODE_RGMII_ID

#define CONFIG_ZYNQ_I2C0
#define CONFIG_ZYNQ_I2C1
#define CONFIG_SYS_I2C_MAX_HOPS		1
#define CONFIG_SYS_NUM_I2C_BUSES	18
#define CONFIG_SYS_I2C_BUSES	{ \
				{0, {I2C_NULL_HOP} }, \
				{0, {{I2C_MUX_PCA9544, 0x75, 0} } }, \
				{0, {{I2C_MUX_PCA9544, 0x75, 1} } }, \
				{0, {{I2C_MUX_PCA9544, 0x75, 2} } }, \
				{1, {I2C_NULL_HOP} }, \
				{1, {{I2C_MUX_PCA9548, 0x74, 0} } }, \
				{1, {{I2C_MUX_PCA9548, 0x74, 1} } }, \
				{1, {{I2C_MUX_PCA9548, 0x74, 2} } }, \
				{1, {{I2C_MUX_PCA9548, 0x74, 3} } }, \
				{1, {{I2C_MUX_PCA9548, 0x74, 4} } }, \
				{1, {{I2C_MUX_PCA9548, 0x75, 0} } }, \
				{1, {{I2C_MUX_PCA9548, 0x75, 1} } }, \
				{1, {{I2C_MUX_PCA9548, 0x75, 2} } }, \
				{1, {{I2C_MUX_PCA9548, 0x75, 3} } }, \
				{1, {{I2C_MUX_PCA9548, 0x75, 4} } }, \
				{1, {{I2C_MUX_PCA9548, 0x75, 5} } }, \
				{1, {{I2C_MUX_PCA9548, 0x75, 6} } }, \
				{1, {{I2C_MUX_PCA9548, 0x75, 7} } }, \
				}

#define CONFIG_SYS_I2C_ZYNQ
#define CONFIG_AHCI

/* I2C */
#if defined(CONFIG_SYS_I2C_ZYNQ)
# define CONFIG_CMD_I2C
# define CONFIG_SYS_I2C
# define CONFIG_SYS_I2C_ZYNQ_SPEED		100000
# define CONFIG_SYS_I2C_ZYNQ_SLAVE		0
#endif

#ifdef CONFIG_AHCI
#define CONFIG_LIBATA
#define CONFIG_SCSI_AHCI
#define CONFIG_SCSI_AHCI_PLAT
#define CONFIG_SYS_SCSI_MAX_SCSI_ID	1
#define CONFIG_SYS_SCSI_MAX_LUN		1
#define CONFIG_SYS_SCSI_MAX_DEVICE	(CONFIG_SYS_SCSI_MAX_SCSI_ID * \
					 CONFIG_SYS_SCSI_MAX_LUN)
#define CONFIG_CMD_SCSI
#endif

#define CONFIG_ZYNQMP_XHCI_LIST {ZYNQMP_USB0_XHCI_BASEADDR}

#if defined(CONFIG_ZYNQMP_USB)
#define CONFIG_USB_MAX_CONTROLLER_COUNT         1
#define CONFIG_SYS_USB_XHCI_MAX_ROOT_PORTS      2
#define CONFIG_USB_STORAGE
#define CONFIG_USB_XHCI_ZYNQMP

#define CONFIG_SYS_DFU_DATA_BUF_SIZE	0x1800000
#define DFU_DEFAULT_POLL_TIMEOUT	300
#define CONFIG_USB_FUNCTION_DFU
#define CONFIG_DFU_RAM
#define CONFIG_USB_CABLE_CHECK
#define CONFIG_CMD_THOR_DOWNLOAD
#define CONFIG_USB_FUNCTION_THOR
#define CONFIG_THOR_RESET_OFF
#define DFU_ALT_INFO_RAM \
		"dfu_ram_info=" \
	"setenv dfu_alt_info " \
	"Image ram $kernel_addr $kernel_size\\\\;" \
	"system.dtb ram $fdt_addr $fdt_size\0" \
	"dfu_ram=run dfu_ram_info && dfu 0 ram 0\0" \
	"thor_ram=run dfu_ram_info && thordown 0 ram 0\0"

#define DFU_ALT_INFO  \
		DFU_ALT_INFO_RAM
#endif

#if defined(CONFIG_ZYNQMP_USB)
#define BOOT_TARGET_DEVICES_USB(func)	func(USB, usb, 0) func(USB, usb, 1)
#else
#define BOOT_TARGET_DEVICES_USB(func)
#endif


#define CONFIG_SYS_SDRAM_BASE   0x0
#define CONFIG_SYS_SDRAM_SIZE   0x80000000


/* PREBOOT - remove DHCP for faster boot*/
#define CONFIG_PREBOOT  "echo U-BOOT for ${hostname};setenv preboot; echo"

/* Extra U-Boot Env settings - Fix for SD1 boot*/
#define CONFIG_EXTRA_ENV_SETTINGS \
    SERIAL_MULTI \
    CONSOLE_ARG \
    PSSERIAL0 \
    "nc=setenv stdout nc;setenv stdin nc;\0" \
    "ethaddr=00:0a:35:00:22:01\0" \
    "autoload=no\0" \
    "clobstart=0x01000000\0" \
    "netstart=0x04000000\0" \
    "dtbnetstart=0x02800000\0" \
    "loadaddr=0x01000000\0" \
    "boot_img=BOOT.BIN\0" \
    "boot_offset=0x00000000\0" \
    "boot_size=0x02000000\0" \
    "kernel_img=image.ub\0" \
    "kernel_offset=0x02000000\0" \
    "kernel_size=0x02000000\0" \
    "dtb_img=system.dtb\0" \
    "load_boot=tftpboot ${clobstart} ${boot_img}\0" \
    "bootenv_size=0x20000\0" \
    "bootenv_offset=0x40000\0" \
    "eraseenv=sf probe 0 && sf erase ${bootenv_offset} ${bootenv_size}\0" \
    "load_kernel=tftpboot ${clobstart} ${kernel_img}\0" \
    "cp_kernel2ram=mmcinfo && fatload mmc 1 ${netstart} ${kernel_img}\0" \
    "sd_boot=echo; echo Boot from SD Card; echo; mmcinfo && mmc dev 1 && fatload mmc 1 ${netstart} ${kernel_img}\0" \
    "sf_boot=echo; echo Boot from QSPI; echo; sf probe 0 && sf read ${netstart} ${kernel_offset} ${kernel_size}\0" \
    "update_sf=echo Reflashing QSPI from SD... && " \
        "mmcinfo && mmc dev 1 && fatload mmc 1 ${netstart} ${boot_img} && sf probe 0 && sf erase ${boot_offset} ${boot_size} && sf write ${netstart} ${boot_offset} ${filesize} && " \
        "fatload mmc 1 ${netstart} ${kernel_img} && sf erase ${kernel_offset} ${kernel_size} && sf write ${netstart} ${kernel_offset} ${filesize}\0" \
    "netboot=tftpboot ${netstart} ${kernel_img} && bootm\0" \
    "default_bootcmd=run sd_boot; bootm ${netstart}\0" \
""
/*    "default_bootcmd=if mmc dev 1; then run sd_boot; else run sf_boot; fi; bootm ${netstart}\0" \ */

